require 'uri'
require 'net/http'
require 'spotify/charts/client'

RSpec.describe Spotify::Charts::Client do
  describe '.base_uri' do
    it 'returns the Spotify Charts API base uri' do
      expect(subject.class.base_uri).to eq('http://charts.spotify.com/api/tracks')
    end
  end

  describe '#request' do
    let(:endpoint) { '/most_viral/global/latest' }

    before do
      uri = URI(subject.class.base_uri + endpoint)
      allow(Net::HTTP).to receive(:get).with(uri).once { '{"example":"json"}' }
    end

    it 'parses JSON response' do
      expect(subject.request(endpoint)).to eq({'example' => 'json'})
    end
  end
end
